#!/usr/bin/env python

from getopt import getopt, GetoptError
from elementtree.ElementTree import Element, tostring
from sss.server import EventReceiver
from sys import argv, exit

class printevent(EventReceiver):
    def __setup__(self):
        data={'c':'**','m':'**','d':'**'}
        for i in ['component','msg','data']:
            if self.kwargs.has_key(i):
                data[i] = self.kwargs[i]
        self.__subscriptions__ = [(data['c'], data['m'], data['d'])]
        
    def HandleEvent(self, xe, (peer,port)):
        for event in xe.getchildren():
            print tostring(event)
        return Element("event-ok")

if __name__ == '__main__':
    try:
        (opts,args)=getopt(argv[1:],'dc:m:')
    except:
        print "Usage: event_tail.py -d [-c component] [-m msg] [-i data]"
        exit(1)
    debug=len([x for x in opts if x == ('-d', '')])
    component="**"
    msg="**"
    data="**"
    tmp=[x[1] for x in filter(lambda x:x[0]=='-c',opts)]
    if tmp: component=tmp[0]
    tmp=[x[1] for x in filter(lambda x:x[0]=='-m',opts)]
    if tmp: msg=tmp[0]
    tmp=[x[1] for x in filter(lambda x:x[0]=='-i',opts)]
    if tmp: data=tmp[0]
    server=printevent(component=component,msg=msg,data=data,debug=debug)
    server.ServeForever()
