from xml.dom.minidom import Document
from string import join

class Node:
    typemap={}
    __attrfields__=[]
    __textfields__=[]
    def __init__(self,xml):
        self.tagname=xml.tagName
        self.children=[]
        self.__setdefaults__()
        map(lambda (attr,value):setattr(self,attr,value),xml._get_attributes().items())
        for node in filter(lambda x:x.nodeType==1,xml.childNodes):
            if node.tagName in self.__textfields__:
                setattr(self,node.tagName,join(map(lambda x:x.nodeValue,filter(lambda x:x.nodeType==3,node.childNodes)),""))
                continue
            if not self.typemap.has_key(node.tagName):
                self.children.append(Node(node))
            else:
                self.children.append(self.typemap[node.tagName](node))

    def __show__(self):
        for key in dir(self):
            print key, getattr(self,key)

    def toxmldom(self,spec=None):
        ret=Document().createElement(self.tagname)
        for attr in self.__attrfields__: 
            if (((spec and hasattr(spec,attr)) or (not spec)) and hasattr(self,attr)):
                ret.setAttribute(attr,getattr(self,attr))
        for child in self.children:
            ret.appendChild(child.toxmldom(spec))
        for text in self.__textfields__:
            tn=Document().createElement(text)
            tn.appendChild(Document().createTextNode(join(getattr(self,text),'')))
            ret.appendChild(tn)
        return ret

    def __str__(self):
        return self.tagname +":"+ join(map(lambda x:"%s:%s"%(x,getattr(self,x)), dir(self)),' ')

    def __setdefaults__(self):
        pass

    def Match(self,spec):
        for attr in [x for x in dir(spec) if x[0] != '_' and x in self.__attrfields__]:
            if (getattr(spec,attr) != '*') and  getattr(self,attr) != getattr(spec,attr):
                return 0
        for child in spec.children:
            if not filter(lambda x:x.Match(child), self.children):
                return 0
        return 1

    def GetTypedChildren(self,ctype):
        return map(lambda x: x.name,filter(lambda x: isinstance(x,ctype),self.children))
        
class Msgbuf(Node):
    def __init__(self,xml):
        self.tagname=xml.tagName
        self.__setdefaults__()
        map(lambda (attr,value):setattr(self,attr,value),xml._get_attributes().items())
        self.__value__=join(map(lambda x:x.nodeValue,xml.childNodes),'')

    def toxmldom(self,spec=None):
        ret=Document().createElement(self.tagname)
        map(lambda x:ret.setAttribute(x,getattr(self,x)), self.__attrfields__)
        tn=Document().createTextNode(self.__value__)
        ret.appendChild(tn)
        return ret

